from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, File

Sga_Overlap_V0_1_0 = CommandToolBuilder(tool="sga_overlap", base_command=["sga", "overlap"], inputs=[ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="display verbose output")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="use NUM worker threads to compute the overlaps (default: no threading)")), ToolInput(tag="in_error_rate", input_type=Boolean(optional=True), prefix="--error-rate", doc=InputDocumentation(doc="the maximum error rate allowed to consider two sequences aligned (default: exact matches only)")), ToolInput(tag="in_min_overlap", input_type=Int(optional=True), prefix="--min-overlap", doc=InputDocumentation(doc="minimum overlap required between two reads (default: 45)")), ToolInput(tag="in_prefix", input_type=File(optional=True), prefix="--prefix", doc=InputDocumentation(doc="use PREFIX for the names of the index files (default: prefix of the input file)")), ToolInput(tag="in_target_file", input_type=File(optional=True), prefix="--target-file", doc=InputDocumentation(doc="perform the overlap queries against the reads in FILE")), ToolInput(tag="in_exhaustive", input_type=Boolean(optional=True), prefix="--exhaustive", doc=InputDocumentation(doc="output all overlaps, including transitive edges")), ToolInput(tag="in_exact", input_type=Boolean(optional=True), prefix="--exact", doc=InputDocumentation(doc="force the use of the exact-mode irreducible block algorithm. This is faster\nbut requires that no substrings are present in the input set.")), ToolInput(tag="in_seed_length", input_type=Int(optional=True), prefix="--seed-length", doc=InputDocumentation(doc="force the seed length to be LEN. By default, the seed length in the overlap step\nis calculated to guarantee all overlaps with --error-rate differences are found.\nThis option removes the guarantee but will be (much) faster. As SGA can tolerate some\nmissing edges, this option may be preferable for some data sets.")), ToolInput(tag="in_seed_stride", input_type=Int(optional=True), prefix="--seed-stride", doc=InputDocumentation(doc="force the seed stride to be LEN. This parameter will be ignored unless --seed-length\nis specified (see above). This parameter defaults to the same value as --seed-length")), ToolInput(tag="in_sample_rate", input_type=Int(optional=True), prefix="--sample-rate", doc=InputDocumentation(doc="sample the symbol counts every N symbols in the FM-index. Higher values use significantly\nless memory at the cost of higher runtime. This value must be a power of 2 (default: 128)"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Sga_Overlap_V0_1_0().translate("wdl", allow_empty_container=True)

